local UIConfig = CreateFrame("Frame", "KillsRestedXPFrame", UIParent, "BasicFrameTemplate")

KillsRestedXPFrame:RegisterEvent("ADDON_LOADED")
KillsRestedXPFrame:RegisterEvent("PLAYER_XP_UPDATE")
KillsRestedXPFrame:RegisterEvent("PLAYER_LEVEL_UP")
KillsRestedXPFrame:RegisterEvent("UPDATE_EXHAUSTION")
KillsRestedXPFrame:RegisterEvent("UNIT_PET")
KillsRestedXPFrame:RegisterEvent("UNIT_PET_EXPERIENCE")
KillsRestedXPFrame:RegisterEvent("ZONE_CHANGED")
KillsRestedXPFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
KillsRestedXPFrame:RegisterEvent("PLAYER_CONTROL_LOST")
KillsRestedXPFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
KillsRestedXPFrame:RegisterEvent("PLAYER_LEAVING_WORLD")
KillsRestedXPFrame:RegisterEvent("CINEMATIC_START")
KillsRestedXPFrame:RegisterEvent("CINEMATIC_STOP")
KillsRestedXPFrame:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
KillsRestedXPFrame:RegisterEvent("PLAYER_TARGET_CHANGED")

KillsRestedXPFrame:SetMovable(true)
KillsRestedXPFrame:EnableMouse(true)
KillsRestedXPFrame:RegisterForDrag("LeftButton")
KillsRestedXPFrame:SetScript("OnDragStart", KillsRestedXPFrame.StartMoving)
KillsRestedXPFrame:SetScript("OnDragStop", KillsRestedXPFrame.StopMovingOrSizing)

KillsRestedXPFrame:SetClampedToScreen(true)

local RestedID, RestedState, RestedMultiplier = GetRestState()
RestedXP = GetXPExhaustion()
TName = 'none'
TLevel = 0
TimesThrough = 0
indexValue = 0
levelPoint = 0

XPPerKill = {}

UIConfig:SetSize(140,30)
UIConfig:SetPoint("LEFT",UIParent,"LEFT")
print('Kills Rested XP Loaded')

KillsRestedXPFrame:SetScript("OnEvent",

function (self,event,...)
	if event == "PLAYER_XP_UPDATE" or event == "PLAYER_ENTERING_WORLD" or event == "ADDON_LOADED" or event == "ZONE_CHANGED_NEW_AREA" or event == "ZONE_CHANGED" or event == "PLAYER_TARGET_CHANGED" then
	
		if event == "PLAYER_TARGET_CHANGED" then
			eliteOrNot = UnitClassification('target')
			--print ('Elite? ' .. eliteOrNot)
		end
	
		--print('Inside event ' .. event)
		
		CharLevel = UnitLevel("Player")
		
		if CharLevel == MAX_PLAYER_LEVEL then
			UIConfig:Hide()
		end
		
		groupSize = GetNumGroupMembers()
		
		KillsLeft = {}
	
		RestedID, RestedState, RestedMultiplier = GetRestState()
	
		--print('ID ' .. RestedID .. ' State ' .. RestedState .. ' Multiplier ' .. RestedXP)
	
		if RestedMultiplier ~= nil then
			
			--CharLevel = UnitLevel("Player")
			
			mapID = C_Map.GetBestMapForUnit("player")
			currentZoneID = C_Map.GetMapInfo(mapID).name
			--print(C_Map.GetMapInfo(mapID).parentMapID)
			
			--print(currentZoneID)
			
			if currentZoneID == "Hellfire Peninsula" then
				toAddOn = 235
			elseif currentZoneID == "Zangarmarsh" then
				toAddOn = 235
			elseif currentZoneID == "Blade's Edge Mountains" then
				toAddOn = 235
			elseif currentZoneID == "Netherstorm" then
				toAddOn = 235
			elseif currentZoneID == "Nagrand" then
				toAddOn = 235
			elseif currentZoneID == "Terokkar Forest" then
				toAddOn = 235
			elseif currentZoneID == "Shadowmoon Valley" then
				toAddOn = 235
			else
				toAddOn = 45
			end
			
			--print(toAddOn)
			
			BaseXP = (CharLevel*5)+toAddOn
			
			RestedXP = GetXPExhaustion()
			
			if RestedXP == nil then
				RestedXP = 0
			end
			
			--print('RestedXP ' .. RestedXP)
		
			--[[UIConfig.title = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
			UIConfig.title:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, 0)
			UIConfig.title:SetText("Rest: " .. RestedXP)]]
			
			CharLevel = UnitLevel("Player")
			if CharLevel >= 1 and CharLevel <= 5 then
				grayLevel = 0
			elseif CharLevel >= 6 and CharLevel <= 49 then
				grayLevel = CharLevel - math.floor(CharLevel/10)-4
			elseif CharLevel == 50 then
				grayLevel = 39
			elseif CharLevel >= 51 and CharLevel <= 59 then
				grayLevel = CharLevel - math.floor(CharLevel/5)
			elseif CharLevel == 60 then
				grayLevel = 50
			end
			
			if grayLevel == 0 then
				grayLevel = 1
			end
			
			maxLevel = CharLevel+4	
			if maxLevel > MAX_PLAYER_LEVEL then
				maxLevel = MAX_PLAYER_LEVEL
			end
			
			levelsShown = maxLevel - grayLevel + 1
			WindowHeight = 50+(20*levelsShown)		
			UIConfig:SetSize(120,WindowHeight)
			
			for levelOver = 1, 4, 1 do
				enemyLevel = CharLevel+levelOver
				XPPerKill[enemyLevel] = (math.ceil(BaseXP*(1+0.05*(enemyLevel-CharLevel))))
			end
			
			if CharLevel >= 1 and CharLevel <= 7 then
				ZD = 5
			elseif CharLevel >= 8 and CharLevel <= 9 then
				ZD = 6
			elseif CharLevel >= 10 and CharLevel <= 11 then
				ZD = 7
			elseif CharLevel >= 12 and CharLevel <= 15 then
				ZD = 8
			elseif CharLevel >= 16 and CharLevel <= 19 then
				ZD = 9
			elseif CharLevel >= 20 and CharLevel <= 29 then
				ZD = 11
			elseif CharLevel >= 30 and CharLevel <= 39 then
				ZD = 12
			elseif CharLevel >= 40 and CharLevel <= 44 then
				ZD = 13
			elseif CharLevel >= 45 and CharLevel <= 49 then
				ZD = 14
			elseif CharLevel >= 50 and CharLevel <= 54 then
				ZD = 15
			elseif CharLevel >= 55 and CharLevel <= 59 then
				ZD = 16
			elseif CharLevel >= 60 and CharLevel <= 79 then
				ZD = 17
			end
			
			for levelUnder = grayLevel, CharLevel-1, 1 do
				XPPerKill[levelUnder] = (round(BaseXP*(1-(CharLevel-levelUnder)/ZD)))
			end
			
			XPPerKill[CharLevel] = BaseXP
			
			RestedXP = GetXPExhaustion()
			
			if RestedXP == nil then
				RestedXP = 0
			end
			
			--print(RestedXP)
			
			if TimesThrough >= 1 then
				if UIConfig.title ~= nil then
					UIConfig.title:SetText('')
				end
				if UIConfig.index1 ~= nil then
					UIConfig.index1:SetText('')
				end
				if UIConfig.index2 ~= nil then
					UIConfig.index2:SetText('')
				end
				if UIConfig.index3 ~= nil then
					UIConfig.index3:SetText('')
				end
				if UIConfig.index4 ~= nil then
					UIConfig.index4:SetText('')
				end
				if UIConfig.index5 ~= nil then
					UIConfig.index5:SetText('')
				end
				if UIConfig.index6 ~= nil then
					UIConfig.index6:SetText('')
				end
				if UIConfig.index7 ~= nil then
					UIConfig.index7:SetText('')
				end
				if UIConfig.index8 ~= nil then
					UIConfig.index8:SetText('')
				end
				if UIConfig.index9 ~= nil then
					UIConfig.index9:SetText('')
				end
				if UIConfig.index10 ~= nil then
					UIConfig.index10:SetText('')
				end
				if UIConfig.index11 ~= nil then
					UIConfig.index11:SetText('')
				end
				if UIConfig.index12 ~= nil then
					UIConfig.index12:SetText('')
				end
				if UIConfig.index13 ~= nil then
					UIConfig.index13:SetText('')
				end
				if UIConfig.index14 ~= nil then
					UIConfig.index14:SetText('')
				end
				if UIConfig.index15 ~= nil then
					UIConfig.index15:SetText('')
				end
				if UIConfig.index16 ~= nil then
					UIConfig.index16:SetText('')
				end
				if UIConfig.index17 ~= nil then
					UIConfig.index17:SetText('')
				end
			end
			
			levelPoint = 0
			
			for printXP = grayLevel, maxLevel, 1 do
				
				levelPoint = levelPoint + 1
				
				deltaY = 0-(((levelPoint-1)*20)+43)
				
				if printXP < CharLevel-2 then
					levelColor = '|cff5fe65d'
				elseif printXP >= CharLevel-2 and printXP <= CharLevel+2 then
					levelColor = '|cffe4e400'
				elseif printXP == CharLevel+3 or printXP == CharLevel+4 then
					levelColor = '|cfff26000'
				elseif printXP >= CharLevel+5 then
					levelColor = '|cffff0000'
				end
				
				if groupSize == 3 then
					groupMod = 1.166
				elseif groupSize == 4 then
					groupMod = 1.3
				elseif groupSize == 5 then
					groupMod = 1.4
				else
					groupMod = 1
				end
				
				if groupSize == 0 then
					groupSize = 1
				end
				
				--print('Groupsize ' .. groupSize .. ' groupMod ' .. groupMod .. ' mult ' .. RestedMultiplier)
				
				--XPPerKill[printXP] = math.ceil(XPPerKill[printXP]/groupSize*groupMod*RestedMultiplier)
				XPPerKill[printXP] = math.ceil(XPPerKill[printXP]/groupSize*groupMod)
				
				if RestedXP > XPPerKill[printXP] then
					XPPerKill[printXP] = XPPerKill[printXP]*2
				else
					XPPerKill[printXP] = XPPerKill[printXP]+RestedXP
				end
				
				if eliteOrNot == 'elite' then
					XPPerKill[printXP] = XPPerKill[printXP]	* 2
				end
				
				if RestedXP ~= nil then
					--print('Inside KillsLeft RestedXP = ' .. RestedXP .. ' printXP = ' .. printXP)
					--print('GrayLevel = ' .. grayLevel .. ' maxLevel = ' .. maxLevel)
					KillsLeft[printXP] = math.ceil(RestedXP/XPPerKill[printXP])
				end
				
				if KillsLeft[printXP] == nil then
					KillsLeft[printXP] = 0
				end
				
				currentXP = UnitXP("player")
				XPMax = UnitXPMax("player")
				
				XPToLevel = XPMax - currentXP
				
				killsToLevel = math.ceil(XPToLevel/XPPerKill[printXP])
				
				
				--print('current ' .. currentXP .. ' max ' .. XPMax)
				
				pxpString = tostring(printXP)
				xppkString = tostring(XPPerKill[printXP])
				klString = tostring(KillsLeft[printXP])
				
				--print('pxpS ' .. pxpString .. ' xppkS ' .. xppkString)
				
				pxpLength = #pxpString
				xppkLength = #xppkString
				klLength = #klString
				
				--print('pxpL ' .. pxpLength .. ' xppkL ' .. xppkLength)
				
				if pxpLength == 1 then
					pxpString = pxpString .. '  '
				else
					pxpString = pxpString .. ' '
				end
				
				if xppkLength == 1 then
					xppkString = xppkString .. '    '
				elseif xppkLength == 2 then
					xppkString = xppkString .. '   '
				elseif xppkLength == 3 then
					xppkString = xppkString .. '  '
				else
					xppkString = xppkString .. ' '
				end
				
				if klLength == 1 then
					klString = klString .. '    '
				elseif klLength == 2 then
					klString = klString .. '   '
				elseif klLength == 3 then
					klString = klString .. '  '
				else
					klString = klString .. ' '
				end
				
				if levelPoint == 1 then
					UIConfig.index1 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index1:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index1:SetText(levelColor .. pxpString .. xppkString .. killsToLevel .. '|r')
				elseif levelPoint == 2 then
					UIConfig.index2 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index2:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index2:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 3 then
					UIConfig.index3 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index3:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index3:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 4 then
					UIConfig.index4 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index4:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index4:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 5 then
					UIConfig.index5 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index5:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index5:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 6 then
					UIConfig.index6 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index6:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index6:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 7 then
					UIConfig.index7 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index7:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index7:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 8 then
					UIConfig.index8 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index8:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index8:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 9 then
					UIConfig.index9 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index9:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index9:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 10 then
					UIConfig.index10 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index10:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index10:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 11 then
					UIConfig.index11 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index11:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index11:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 12 then
					UIConfig.index12 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index12:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index12:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 13 then
					UIConfig.index13 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index13:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index13:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 14 then
					UIConfig.index14 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index14:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index14:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 15 then
					UIConfig.index15 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index15:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index15:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 16 then
					UIConfig.index16 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index16:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index16:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				elseif levelPoint == 17 then
					UIConfig.index17 = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					UIConfig.index17:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, deltaY)
					UIConfig.index17:SetText(levelColor .. pxpString .. xppkString .. killsToLevel ..  '|r')
				end
				
				--print(indexValue .. ' ' .. printXP .. ' ' .. XPPerKill[printXP] .. ' ' .. KillsLeft[printXP])
			end	
			
			UIConfig.title = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
			UIConfig.title:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, 0)
			UIConfig.title:SetText('')
			
			if RestedXP == nil then
				RestedXP = 0
			end
			
			UIConfig.title = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
			UIConfig.title:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, 0)
			UIConfig.title:SetText("Rest: " .. RestedXP)
			
			UIConfig.header = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
			UIConfig.header:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, -23)
			UIConfig.header:SetText('|cffff00ffML XP   Kills|r')
			
			TimesThrough = TimesThrough + 1
		else
			--print(event)
		end
	elseif RestedMultiplier ~= 2 and RestedMultiplier ~= nil then
		--print('KillsResstedXP - Hiding Window')
		--UIConfig:Hide()
	else
		--print('Opening ' .. event)
	end
end)

function round(n)
    return n % 1 >= 0.5 and math.ceil(n) or math.floor(n)
end
